// file: /u1/picone/jeida/excise_signal/excise_signal.h
//
// this file defines constants used in excise_signal.C
//

// Make sure this file is only included once
//
#ifndef __ISIP_EXCISE_SIGNAL
#define __ISIP_EXCISE_SIGNAL

// important constants
//
#define ISIP_PROGRAM_NAME "excise_signal"

// define default values
//
#define DEFAULT_SAMPLE_FREQ 16000.0
#define DEFAULT_START_TIME 0.0
#define DEFAULT_END_TIME -1.0
#define DEFAULT_NUMBER_BYTES_PER_SAMPLE 2
#define DEFAULT_NUMBER_OF_CHANNELS 2
#define DEFAULT_BUFFER_SIZE 64000

// define some useful math constants
//
#define DEFAULT_LARGE_NUMBER (int_4)(ISIP_2EXP31 - 1)

// define command line identifiers
//
#define ISIP_OPT_SF "-sf"
#define ISIP_OPT_START "-start"
#define ISIP_OPT_END "-end"
#define ISIP_OPT_NBYTES "-num_bytes"
#define ISIP_OPT_NCHAN "-num_chan"

// function definitions
//
logical_1 get_parameters_C(int argc, char** argv, float_4& sf,
			   float_4& start_time, float_4& end_time,
			   int_4& num_bytes, int_4& num_chan,
			   char_1* file_in, char_1* file_out);

//
// end of file
#endif
