//
// get system level files

#include <stdio.h>

// get local files

#include "make_files.h"

void write_data(int_2 *channel_0, int_2 *channel_1, uint_4 samples_read,
		int_1 number_of_channels, int utterance_number,
		char *output_dir, char *base_name, char *prefix, 
		char *extension)
{
  FILE *output_file=NULL;
  char output_file_name[MAX_LINE_LENGTH]=DEFAULT_OUTPUT_FILE_NAME;

  // write the first file (channel 0)
  
  sprintf(output_file_name, CHANNEL_0_FORMAT, output_dir, 
	  base_name, prefix, utterance_number, extension);
  fprintf(stdout, "%s", output_file_name);
  if(!(output_file = fopen(output_file_name, "w")))
    {
      fprintf(stderr, 
	      "Error! Unable to open file for output of channel 0 data.\n");
    }
  else
    {
      (void)fwrite(channel_0, SAMPLE_SIZE, 
		   (unsigned int)samples_read / number_of_channels, 
		   output_file);
      fclose(output_file);
    }
  if(number_of_channels == 2)
    {
      // write second file (channel 1)
      
      sprintf(output_file_name, CHANNEL_1_FORMAT, output_dir,
	    base_name, prefix, utterance_number, extension);
      fprintf(stdout, "%s", output_file_name);
      if(!(output_file=fopen(output_file_name, "w")))
	{
	  fprintf(stderr, 
		  "Error!  Could not open file for output of channel 1 data.\n");
	}
      else
	{
	  (void)fwrite(channel_1, SAMPLE_SIZE, samples_read / 
		       number_of_channels, output_file);
	  fclose(output_file);
	}
    }
  fprintf(stdout, "\n");
}
      





