
#ifndef __ISIP_PROGRAM
#define __ISIP_PROGRAM
#endif

#ifndef MAX_LINE_LENGTH
#define MAX_LINE_LENGTH 80
#endif

#ifndef DEFAULT_PARAM_FILE
#define DEFAULT_PARAM_FILE "endpointer_00.params" 
#endif

#ifndef DEFAULT_OUTPUT_FILE
#define DEFAULT_OUTPUT_FILE "endpoints.dat"
#endif

#ifndef SAMPLE_SIZE
#define SAMPLE_SIZE 2   /* 2 bytes */
#endif

#ifndef FALSE
#define FALSE 0
#endif

#ifndef TRUE
#define TRUE 1
#endif

typedef float energytype;


// system include files

#include <fstream.h>
#include <iostream.h>
#include <stdlib.h>        // for malloc()
#include <stdio.h>
#include <math.h>

// isip include files

// #include <math/integral/integral.h>

// local include files


struct parameter_data 
{
  float number_of_channels, sample_type, channel_to_be_processed, sample_frequency, frame_duration; 
  float nominal_noise_level, nominal_signal_level, noise_adaptation_constant, signal_adaptation_constant;
float nominal_noise_constant, nominal_signal_constant, noise_adaptation_delta, signal_adaptation_delta, utterance_delta;
  float signal_adaptation_threshold, minimum_utterance_duration, minimum_utterance_separation;
  float initial_padtime, final_padtime;
  int debug_level;
  float noise_floor;
};

struct critical_points_struct
{
  float time;
  bool positive_slope;
};



