// file: find_critical_points.cc

#include "endpointer.h"

// main function

int find_critical_points(float *signal_array, float *noise_array, int size_of_energy_array, struct critical_points_struct *critical_point, int critical_points_max, struct parameter_data *parameter)
{
  
// variable declarations

  int counter;
  bool last_point_positive_slope;
  float time;
  int critical_points_counter;
  struct critical_points_struct *cps_pointer;

// signal and noise are both initialized to nominal_noise_level, so that
// an upward sloping critical point will always occur first.


counter = 0;
time = 0;
cps_pointer = critical_point;
critical_points_counter = 0;
last_point_positive_slope = FALSE;
while((counter < size_of_energy_array) && (critical_points_counter < critical_points_max))
  {

// check for critical point with positive slope

    if((!last_point_positive_slope) && ((signal_array[counter]-noise_array[counter]) >= parameter->utterance_delta))
      {
	cps_pointer->time = time;
	cps_pointer->positive_slope = TRUE;
	last_point_positive_slope = TRUE;
//	printf("critical point #%3d was found at time %5.2f and has slope %d\n",critical_points_counter, cps_pointer->time, cps_pointer->positive_slope);
	critical_points_counter ++;
	cps_pointer ++;
      }

// check for critical point with negative slope

    if((last_point_positive_slope) && ((signal_array[counter]-noise_array[counter]) < parameter->utterance_delta))
      {
	cps_pointer->time = time;
	cps_pointer->positive_slope = FALSE;
	last_point_positive_slope = FALSE;
//	printf("critical point #%3d was found at time %5.2f and has slope %d\n",critical_points_counter, cps_pointer->time, cps_pointer->positive_slope);
	critical_points_counter ++;
	cps_pointer ++;
      }
 
    counter ++;
    time += parameter->frame_duration;
  
  }

return(critical_points_counter);
}





























































































































































































































































































































































































































































































