# file: $JEIDA/src/validate/v1.0/src/display_load_file.tcl
#
# This procedure creates a new toplevel window and prompts the user
# to enter a filenumber to load
#

proc display_load_file {} {

    # import the global variables
    #
    global p
    global lp

    # set the name for the new toplevel
    #
    set lp "$p.lp"

    # destroy the new toplevel if it exists
    #
    catch {destroy $lp}

    # create the new toplevel
    #
    toplevel $lp -height 100 -width 400
    wm title $lp "Load File"
      

    # create the frames that will be used in packing
    #
    frame $lp.top_frame 
    frame $lp.bot_frame 
    
    # create the file number entry widget and label
    #
    entry $lp.filenum -relief sunken -textvariable file_pos
    label $lp.label -relief raised -text "File Number:" -height 2
    
    # bind the return key in the entry widget to execute as the
    # load button would
    #
    bind $lp.filenum <Return> {
	load_file $file_pos
	destroy $lp
    }
    
    # set up the load button
    # behavior is the same as hitting <Return> in entry widget
    #
    button $lp.loadb -text "Load" -command {
	load_file $file_pos
	destroy $lp
    } -height 2
	
    # set up the dismiss window button
    #
    button $lp.dismiss -text Dismiss -command {destroy $lp.}
    
    # pack the frames into the toplevel window
    #
    pack $lp.top_frame $lp.bot_frame -side top -fill both
        
    # pack the widgets into the frames
    #
    pack $lp.label $lp.filenum -side left -in $lp.top_frame\
	    -fill both -expand true
    pack $lp.loadb $lp.dismiss -side left -in $lp.bot_frame\
	    -fill both -expand true
}

