# file: $JEIDA/src/validate/v1.0/src/globals.tcl
#
# This file has sets many global variables that are used constantly
# in different parts of the program and initializes other variables
#
global maxcolnum column_separator blank_separator
global p
global transcription_date
global transcriber
global transcription
global comments
global old_transcription
global old_comments
global read_word_list_flag
global full_wordlist
global maxrownum
global width_of_plot
global height_of_plot
global plot_signal_program
global label_transcription_saved label_transcription_edited
global default_audio_command
global tmp_file_name
global env
global wordlist_directory
global utterances_in_set
global repetitions_in_session
global speaker_number
global speaker_sex
global utterance_number
global utterance_type
global repetition_number
global out_file_format
global output_directory
global garbage_transcription
global needs_review_transcription
global no_output_directory
global ncd_play

# set the maximum number of columns and rows for the wordlist listboxes
#
set maxcolnum 5
set maxrownum 25

# width of frame is 246 + (146 * maxcolnum)
#
set width_of_plot [expr 230 + (146 * $maxcolnum)]
set height_of_plot 200

# set the constants that are recognized as special entries in the
# wordlist files
#
set column_separator "<next_column>"
set blank_separator "<blank_line>"

# set the name and information for the main toplevel
#
set p .top
set validator_title "JEIDA Validator"

# set the format for the out file name
#
set out_file_format "%s%4d_%s%3d_r%1d.val"

# initialize variables
#
set read_word_list_flag 0
set full_wordlist ""
set transcription_date ""
set transcriber ""
set transcription ""
set comments ""
set old_transcription ""
set old_comments ""
set utterances_in_set 15
set repetitions_in_session 4
set speaker_number 1
set speaker_sex m
set utterance_type d
set utterance_number 1
set repetition_number 1
set garbage_transcription "<garbage>"
set needs_review_transcription "<needs_review>"
set no_output_directory "NO OUTPUT"

# set the text for the visible astrick for the save flag
#
set label_transcription_edited "*Enter Transcription:"
set label_transcription_saved " Enter Transcription:"

# set the name and path of the plot_signal program
#
set plot_signal_program \
	"$env(JEIDA)/src/plot_signal/v1.0/src/plot_signal_tcl.exe" 


# set the default audio command
#
set default_audio_command naplay

# set the temporary file name
#
set proc_id [pid]
set tmp_file_name "/tmp/validator.$proc_id.tmp"

# set the directory for the wordlists
#
set wordlist_directory "/isip/d00/jeida/src/validate/v2.0/wordlists/"

# set ncd_play to null if not on a terminal that has sound capability
#
if {([string first 19c $env(DISPLAY)] > 0) || ([string first 20c $env(DISPLAY)]> 0)} {
    set ncd_play "cat %s | sox -r %s -t .sw - -t .au - | auplay -audio $env(DISPLAY)"
} else {
    set ncd_play ""
}

# end of file








