# file $JEIDA/src/validate/v1.0/src/plotter.tcl
#
# this procedure draws the plot from the temporary data file
#

proc plot {} {
    global amplitude
    global length
    global env
    global p
    global tmp_file_name

    # open the data file
    #
    set the_file [open $tmp_file_name]
    
    set index 0
    
    $p.plot delete plot_tag

    # read in the header information from the plot file
    #
    gets $the_file amplitude
    gets $the_file length
    gets $the_file num_points
    
    # configure the amplitude and length widgets
    #
    $p.plot.amplitude configure -text "Amplitude: $amplitude units"
    $p.plot.length configure -text "Length $length secs"
    
    # read in the points and draw them in the plot canvas widget
    #
    gets $the_file line
    scan $line "%f %f" x1 y1
    while {($index < $num_points) && ([gets $the_file line] >= 0) }  {
	scan $line "%f %f" x2 y2
	$p.plot create line $x1 $y1 $x2 $y2 -tags plot_tag
	set x1 $x2
	set y1 $y2
	incr index 1
    }
    close $the_file
    catch { exec rm $tmp_file_name }
}


