# file $JEIDA/src/validate/v1.0/src/save_file.tcl
#
# This procedure saves a validation file
#

proc save_file {} {
    global val_file_name
    global speech_data_file
    global validation_file_extension
    global number_of_channels
    global channel_to_be_processed
    global sample_frequency
    global wordlist
    global audio_command
    global transcription
    global env
    global comments
    global transcriber
    global transcription_date
    global flag_file
    global my_file
    global full_wordlist
    global old_transcription
    global old_comments
    global save_flag
    global label_transcription
    global label_transcription_saved label_transcription_edited
    global utterances_in_set
    global repetitions_in_session
    global speaker_sex
    global speaker_number
    global utterance_number
    global utterance_type
    global repetition_number
    global out_file_format
    global output_directory
    global out_filename
    global out_file_label    
    global garbage_transcription
    global needs_review_transcription
    global no_output_directory

    set counter 0
    set extender "_"

    if {$save_flag == 1} {
	# restore filename for saving, in case it is valfile.default
	
	# interpret the new validation file name
	#
	set val_file_name [exec basename $my_file .raw]
	set val_file_name "$val_file_name.val"
	set val_file_name "[file dirname $my_file]/$val_file_name"

	# create a new validation file name
	#
	if { [file exists $val_file_name] == 1} {
	    set test_file_name "$val_file_name$extender$counter"
	    while { [file exists $test_file_name] == 1} {
		incr counter +1
		set test_file_name "$val_file_name$extender$counter"
	    }
	    exec cp $val_file_name $test_file_name
	    exec rm $val_file_name
	}
	
	# get current data
	#
	
	set transcription_date [exec date]
	set transcriber $env(LOGNAME)
	
	# open file for output, write all data, and close the file
	#
	
	set output_file [open $val_file_name w]
	
	puts $output_file "speech_data_file = $my_file"
	puts $output_file "validation_file_extension = $validation_file_extension"
	puts $output_file "number_of_channels = $number_of_channels"
	puts $output_file "channel_to_be_processed = $channel_to_be_processed"
	puts $output_file "sample_frequency = $sample_frequency"
	puts $output_file "wordlist = \"$full_wordlist\""
	puts $output_file "audio_command = \"$audio_command\""
	puts $output_file "transcription = \"$transcription\""
	puts $output_file "comments = \"$comments\""
	puts $output_file "transcriber = \"$transcriber\""
	puts $output_file "transcription_date = \"$transcription_date\""
	puts $output_file "utterances_in_set = \"$utterances_in_set\""
	puts $output_file "repetitions_in_session = \
		\"$repetitions_in_session\""
	puts $output_file "speaker_sex = \"$speaker_sex\""
	puts $output_file "speaker_number = \"$speaker_number\""
	puts $output_file "utterance_type = \"$utterance_type\""
	puts $output_file "utterance_number = \"$utterance_number\""
	puts $output_file "repetition_number = \"$repetition_number\""
	puts $output_file "output_directory = \"$output_directory\""
	close $output_file

	# copy the validation file to the other channel's data directory,
	# if it exists
	#

	regsub -all {\c\_\0} $my_file "c_1" valfile_c1
	if { $valfile_c1 != $my_file} {
	    set valfile_c1 [file dirname $valfile_c1]
	    if {[file exists $valfile_c1] > 0} {
		set valfile_c1 $valfile_c1/[file tail $val_file_name]
		puts $valfile_c1
		exec cp $val_file_name $valfile_c1
	    }
	}
	if { ($output_directory != $no_output_directory) && \
		([file exists $output_directory] == 0)} {
	    set output_directory $no_output_directory
	}
	if { ($transcription != $garbage_transcription) && \
		($transcription != $needs_review_transcription) && \
		($output_directory != $no_output_directory) } {
	    # prepare the filename for the permanent output_file
	    #
	    set out_filename \
		    [format $out_file_format $speaker_sex \
		    [expr $speaker_number +0] \
		    $utterance_type $utterance_number $repetition_number]
	    regsub -all "\ " $out_filename "0" out_filename
	    
	    # copy the validation file to the permananent output_file
	    #
	    exec cp $val_file_name $output_directory/$out_filename
		    

	    # copy over the raw file
	    #
	    set new_rawfile_name "$output_directory/[string trimright \
		    $out_filename .val]_c0.raw"
	    
	    exec cp $my_file $new_rawfile_name &

	    # copy over the other channel, if it exists
	    #
	    regsub -all {\c\_\0} $my_file "c_1" rawfile_c1
	    regsub -all {\_0.raw} $rawfile_c1 "_1.raw" rawfile_c1
	
	    if { [file exists $rawfile_c1] == 1 } {
		regsub -all c0 $new_rawfile_name c1 new_rawfile_name
		exec cp $rawfile_c1 $new_rawfile_name &
	    } 
	    
	    #set output_file [open "$output_directory/$out_filename" w]
	    
	}
	
	# reupdate the display
	#
	# update_window
	
	# set the save flag and the visible astrick
	#
	set save_flag 0
	set label_transcription $label_transcription_saved
    }
}









